Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.util.concurrent
Class ForwardingListenableFuture<V>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.util.concurrent.ForwardingFuture<V>
              com.google.common.util.concurrent.ForwardingListenableFuture<V>

Type Parameters:
  `V` - The result type returned by this Future's `get` method

All Implemented Interfaces:
  ListenableFuture<V>, Future<V>

Direct Known Subclasses:
  ForwardingCheckedFuture, ForwardingListenableFuture.SimpleForwardingListenableFuture

    public abstract class ForwardingListenableFuture<V>

extends ForwardingFuture<V>
implements ListenableFuture<V>

A `ForwardingListenableFuture.SimpleForwardingListenableFuture` which forwards all its method calls to another future. Subclasses should override one or more methods to modify the behavior of the backing future as desired per the decorator pattern.

Most subclasses can just use `ForwardingListenableFuture.SimpleForwardingListenableFuture`.

Since:
  4.0
Author:
  Shardul Deo

Nested Class Summary
`static class` | `ForwardingListenableFuture.SimpleForwardingListenableFuture<V>` A simplified version of `ForwardingListenableFuture` where subclasses can pass in an already constructed `ListenableFuture` as the delegate.

Nested classes/interfaces inherited from class com.google.common.util.concurrent.ForwardingFuture
`ForwardingFuture.SimpleForwardingFuture<V>`

Constructor Summary
`protected` | `ForwardingListenableFuture()` Constructor for use by subclasses.

Method Summary
`void` | `addListener(Runnable listener, Executor exec)` Registers a listener to be run on the given executor.
`protected abstract ListenableFuture<V>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.

Methods inherited from class com.google.common.util.concurrent.ForwardingFuture
`cancel, get, get, isCancelled, isDone`

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.concurrent.Future
`cancel, get, get, isCancelled, isDone`

Constructor Detail

### ForwardingListenableFuture

    protected ForwardingListenableFuture()

  Constructor for use by subclasses.

Method Detail

### delegate

    protected abstract ListenableFuture<V> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingFuture<V>`

### addListener

    public void addListener(Runnable listener,
                            Executor exec)

  Description copied from interface: `ListenableFuture`
  Registers a listener to be run on the given executor. The listener will run when the `Future`'s computation is complete or, if the computation is already complete, immediately.

  There is no guaranteed ordering of execution of listeners, but any listener added through this method is guaranteed to be called once the computation is complete.

  Exceptions thrown by a listener will be propagated up to the executor. Any exception thrown during `Executor.execute` (e.g., a `RejectedExecutionException` or an exception thrown by inline execution) will be caught and logged.

  Note: For fast, lightweight listeners that would be safe to execute in any thread, consider `MoreExecutors.sameThreadExecutor()`. For heavier listeners, `sameThreadExecutor()` carries some caveats: First, the thread that the listener runs in depends on whether the `Future` is done at the time it is added. In particular, if added late, listeners will run in the thread that called `addListener`. Second, listeners may run in an internal thread of the system responsible for the input `Future`, such as an RPC network thread. Finally, during the execution of a `sameThreadExecutor` listener, all other registered but unexecuted listeners are prevented from running, even if those listeners are to run in other executors.

  This is the most general listener interface. For common operations performed using listeners, see `Futures`

  Specified by:
    `addListener` in interface `ListenableFuture<V>`
  Parameters:
    `listener` - the listener to run when the computation is complete
    `exec` - the executor to run the listener in

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.